//
//  main.c
//  NoBitmatrixOpt
//
//  Created by Liu Chengjian on 17/8/28.
//  Copyright (c) 2017年 csliu. All rights reserved.
//

#include <stdio.h>

#include "MeasureGCRS.h"
#include "GCRSCommon.h"
#include "GCRSMatrix.h"

#define ARG_SIZE 5
void Usage(){
    printf("Input:./Program k m workSizePerDataParityBlockInMB loopSize\n");
    exit(0);
}

int main(int argc, const char * argv[]) {
    // insert code here...
    int k, m, w;
    double preTimeElapse;
    int workSizePerDataParityBlock, alignedWorkSizePerDataParityBlock, loopSize;
    float encodingTimeAvg, encodingTimeVariance, decodingTimeAvg, decodingTimeVariance;
    
    if (argc < ARG_SIZE) {
        Usage();
    }
    
    k = atoi(argv[1]);
    m = atoi(argv[2]);
    workSizePerDataParityBlock = atoi(argv[3]);
    loopSize = atoi(argv[4]);
    printf("w \t EncodeTime \t EnThroughput \t DecodeTime \t DeThroughput \t inputDataSize\n");

//for (k = m; k <= MAX_K; ++k) {

    for (w = 4; w <= 8; ++w) {
    
//        w = 4;
//        w = gcrs_check_k_m_w(k, m, w);
        
        if (w == -1) {
            printf("w = -1");
            exit(0);
        }

        alignedWorkSizePerDataParityBlock = workSizePerDataParityBlock * 1024 * 1024;

        if (alignedWorkSizePerDataParityBlock % (w*sizeof(long)) != 0) {
            alignedWorkSizePerDataParityBlock = alignedWorkSizePerDataParityBlock + ((w*sizeof(long)) - alignedWorkSizePerDataParityBlock % (w*sizeof(long)));
        }
        
        measureGCRS(k, m, w,
                    alignedWorkSizePerDataParityBlock, loopSize,
                    &encodingTimeAvg, &encodingTimeVariance,
                    &decodingTimeAvg, &decodingTimeVariance);
        float dataSize = (k)*alignedWorkSizePerDataParityBlock;
        float encodeThroughput = dataSize/encodingTimeAvg*1000.0/1024.0/1024.0/1024.0;
        float decodeThroughput = dataSize/decodingTimeAvg*1000.0/1024.0/1024.0/1024.0;
        preTimeElapse = encodingTimeAvg;
        
//        printf("%d \t %f \t %f \t %f \t %f \t %f\n",
//               w, encodingTimeAvg, encodeThroughput, decodingTimeAvg, decodeThroughput, (dataSize/1024.0/1024.0));
    printf("%d \t %f \t %f \t %f \t %f \t %f\n",
           w, encodingTimeAvg, encodeThroughput, decodingTimeAvg, decodeThroughput, (dataSize/1024.0/1024.0));

    }
//}
    return 0;
}
