//
//  PerformanceMeasure.c
//  PBase
//
//  Created by Liu Chengjian on 16/10/27.
//  Copyright (c) 2016年 csliu. All rights reserved.
//

#include <stdio.h>
#include "PErasureMatrix.h"

#include "PErasureCommon.h"
#include "PErasureMeasure.h"

#define ARG_SIZE 5
void Usage(){
    printf("Input:./Program k m workSizePerDataParityBlockInMB loopSize\n");
    exit(0);
}

int main(int argc, const char * argv[]) {
    // insert code here...
    int k, m, w;
    double preTimeElapse;
    int workSizePerDataParityBlock, alignedWorkSizePerDataParityBlock, loopSize;
    double encodingTimeAvg, encodingTimeVariance, decodingTimeAvg, decodingTimeVariance;
    
    if (argc < ARG_SIZE) {
        Usage();
    }
    
    k = atoi(argv[1]);
    m = atoi(argv[2]);
    workSizePerDataParityBlock = atoi(argv[3]);
    loopSize = atoi(argv[4]);
    printf("w \t EncodeTime \t EnThroughput \t DecodeTime \t DeThroughput \t sizePerBlockInMB\n");
    
    for (w = 4; w <= 8; ++w) {
//        printf("k:%d m:%d w:%d\n",k,m,w);
        alignedWorkSizePerDataParityBlock = workSizePerDataParityBlock * 1024 * 1024;
        
        if (alignedWorkSizePerDataParityBlock % (w*sizeof(long)) != 0) {
            alignedWorkSizePerDataParityBlock = alignedWorkSizePerDataParityBlock + ((w*sizeof(long)) - alignedWorkSizePerDataParityBlock % (w*sizeof(long)));
        }
        
        measure_base_work_size_time_avg(k, m, w,
                                        alignedWorkSizePerDataParityBlock, loopSize,
                                        &encodingTimeAvg, &encodingTimeVariance,
                                        &decodingTimeAvg, &decodingTimeVariance);
        
        double dataSize = (k)*alignedWorkSizePerDataParityBlock;
        double encodeThroughput = dataSize/encodingTimeAvg*1000.0/1024.0/1024.0/1024.0;
        double decodeThroughput = dataSize/decodingTimeAvg*1000.0/1024.0/1024.0/1024.0;
        preTimeElapse = encodingTimeAvg;
        
        printf("%d \t %f \t %f \t %f \t %f \t %f\n",
               w, encodingTimeAvg, encodeThroughput, decodingTimeAvg, decodeThroughput, (dataSize/1024.0/1024.0));

    }
//    for (k = m; k <= MAX_K; ++k) {
//        measure_correctness(k, m, w);
//        continue;
        
//        w = 4;
//        w = perasure_check_k_m_w(k, m, w);
//        
//        if (w == -1) {
//            printf("w = -1");
//            exit(0);
//        }
//        
//        
//    }
    
    return 0;
    
}
